var fs = require('fs');
var process = require('process')
var _ = require('lodash')

var begin = true;
// 程序启动时 判断是否运行中
if(!fs.dirExists("./"+process.evalFileName() + "temp")){
    fs.mkdir("./"+process.evalFileName() + "temp")
} else {
    console.log("程序运行中，退出");
    begin = false;
}

if(begin){
    var exlConfig = require("./config/exlConfig.js");  // 引入excel字段配置
    var dbConfig = require('./config/dbConfig.js');   //  引入数据库配置
    var exl = require("./index.js")({}); // 引入并初始化

    var files = exl.read("../excel"); // 读取文件夹获取文件列表 默认是只读取XLSX后缀文件
    
    var datalist = []; // 存放excel的数据

    _.forEach(files, function(value){
        var res = exl.readExl(value, exlConfig);    // 读取excel文件 根据exl配置返回结果
        datalist = _.concat(datalist, res);   // 将获取到的数据拼接到datalist
        // undo 将读取过的文件 移动到别处
        fs.rename(value,"../remove/"+value.split("/").pop(),true)
    })

    if(datalist.length !== 0){
        // 数据库操作
        var dbDatas = exl.openDb(dbConfig).dbGetAll()   // 连接数据库 链式调用获取所有数据
        console.log("excel的数据数量：" + datalist.length)
        console.log("数据库的数据数量：" + dbDatas.length)
        // Contrast begin 数据比较 将数据库数据 与 excel数据比较 旧数据判断是否要更新 新数据插入
        var newData = contrastData(datalist,dbDatas,exl)    
        if(newData.length !== 0){
            // 执行插入操作
            exl.insertAny(newData)
        }
        // Contrast over
        exl.closeDb()  // 关闭数据库
        // 删除文件夹
    }
    fs.rmdir("./"+process.evalFileName() + "temp")
}

function contrastData(data, dbData, exl){
    dbI = dbData.map(function(v){  // 获取数据库唯一键值对
        var tempStr = ""
        tempStr += v["confirmation"] + v["plant"] + v["material"] + v["posting_date"] + v["confirmation_entry_time"] + v["activity"]
        return tempStr
    })
    var oldData = [],
        newData = [];
    for(var i = 0,len=data.length;i<len;i++){
        var v = data[i]
        var dataI = v["confirmation"] + v["plant"] + v["material"] + v["posting_date"] + v["confirmation_entry_time"] + v["activity"]
        if(dbI.indexOf(dataI) >= 0){
            var updateData = {}
            // 判断老数据是否更新了
            for(var key in v){
                if(key==="attr_data"){
                    var tempflag = false
                    for(var tempdbkey in v["attr_data"]){
                        if(!dbData[dbI.indexOf(dataI)][key][tempdbkey] && dbData[dbI.indexOf(dataI)][key][tempdbkey] != v[key][tempdbkey]){
                            tempflag = true
                        }
                    }
                    if(tempflag){
                        updateData["attr_data"] = v["attr_data"]
                    }
                } else {
                    if(v[key] != dbData[dbI.indexOf(dataI)][key]) {
                        updateData[key] = v[key]
                    }
                }
            }
            if(JSON.stringify(updateData) !== "{}"){ // 有要更新的情况
                console.log("更新...")
                exl.UpdateKeys(updateData, dbData[dbI.indexOf(dataI)]["id"])
            }
            oldData.push(v)
        } else {
            // 新数据
            newData.push(v)
        }
    }
    console.log("新数据："+newData.length);
    console.log("老数据："+oldData.length);
    return newData
}