var fs = require('fs')
var book = require('topsin.excelxs')
var db = require('topsin.database');

// 读取配置文件
var config = JSON.parse(fs.readFile('./config.json'))

// 主
function Main(props){
    this.dirPath = props.dirPath  // xlsx文件夹目录
    // 执行初始化
    this.init()
}
// 初始化方法
Main.prototype.init = function(){
    console.log('init')
    this.dirlist = this.readDir(this.dirPath, -1)
    if(this.dirlist.length === 0){  // 没有文件就退出
        return
    }
    this.readXlsx(this.dirlist)
}
// 读取文件夹 获取xlsx
Main.prototype.readDir = function(path){
    return fs.listDir(path).filter(function(v){return v.completeSuffix === "XLSX"})
}
// 循环读取文件列表 
Main.prototype.readXlsx = function(list){
    var that = this
    list.forEach(function(v){
        // 读取
        that.excelxs(v.dir + '/' + v.name, v.name)
    })
}

// 读取excelxs
Main.prototype.excelxs = function(path,name){
    if(book.open(path)) {
        var sheet = book.getActiveSheet()  // 获取当前表
        
        if(sheet.isNull()){return}

        // 获取表字段数量
        var keysCount = sheet.getLastCol()
        // 获取数据数量
        var dataCount = sheet.getLastRow() - 1
        var datalist = []  // 定义数组 两次循环获取表数据
        for(var j = 1,length = sheet.getLastRow();j<length;j++){
            datalist[j-1] = []
            for(var i = 0;i<keysCount;i++){
                if(i ===5 || i===6){
                    var formatdate = sheet.getCellFormat(j, i)
                    formatdate.setNumFormat('DATE')
                    datalist[j-1].push(sheet.getCellValue(j, i, formatdate))
                } else {
                    datalist[j-1].push(sheet.getCellValue(j, i))
                }
            }
        }
        this.paytionType({
            keysCount:keysCount,
            dataCount:dataCount,
            datalist:datalist
        })
        book.saveAs(config.rdir + '/' + name)  // 读取完的文件另存为 然后可以删除
        // 删除
        // fs.unlink(path)
    }
}
Main.prototype.paytionType = function(props){  // 该如何处理数据
    if(props.keysCount <= config.keys.length){ // 当字段数量小于等于配置文件字段数量时候 只新增
        this.InsertData(props.datalist, config.keys)
    } else {
        console.log('要对字段扩展')
    }
}

Main.prototype.InsertData = function (datas, keys) {  // 新增数据
    console.log("数据库操作")
    db.addConnection(config.dbconfig, "Scott_PMO_TRAINING");
    var tablename = 'sec_production_order_confirmation_2'
    var query = db.query('Scott_PMO_TRAINING');
    var dbDatas = getDbData(query,tablename)
    // 遍历给数据添加key
    datas = datas.map(function(v){
        var obj = {}
        v.map(function(v2, i2){
            obj[keys[i2]] = v2
        })
        return {
            key: v[0]+v[1]+v[2]+v[4]+v[5]+v[6],
            data: obj
        }
    })
    console.log(datas[0].data)
    // 插入一条数据
    // var id = query.insertRow({
    //     table:tablename,
    //     data:datas[0].data,
    //     return_field:'id',
    // });
    // console.log(id)
    db.removeConnection('Scott_PMO_TRAINING');  // 移除数据库操作
}

function getDbData(query,tablename){
    return query.selectArrayMap({
        table:tablename,
        field: '*',
        field_format:{"tags":'array', attr_data:'json'}
    })
}

if(!config.isUseing){  // 如果没在运行程序就可以实例化
    config.isUseing = true
    fs.writeFile('./config.json',JSON.stringify(config)) // 覆盖写入json
    var demo = new Main(config)
    
    book.close()
    config.isUseing = false
    fs.writeFile('./config.json',JSON.stringify(config)) // 覆盖写入json
}



// ["attr_data","action_data","extra_data","tags","sys_tags","sys_data"]

